/*
 *  Author: Li Luo 
 *  Email:  li.luo@siat.ac.cn
 */

#pragma once

namespace cusp
{
   
// create factorization matrix by using MKL routines: dcsrilu0, dcsrilut   
// create from matrix A on device, val is on host, only used in ilu0 
template <typename MatrixType,
	      typename ValueType>
void create_fact_from_mkl(const MatrixType& A,
						  const ValueType* val,
						  MatrixType& A_fact);

// create factorization matrix by using MKL routines: dcsrilu0, dcsrilut   
// create from arrays on host
template <typename IndexType,
          typename ValueType,
		  typename MatrixType>
void create_fact_from_mkl(const IndexType num_rows, 
						  const IndexType num_cols,
						  const IndexType num_entries,
						  const IndexType* row_off,
						  const IndexType* col_ind,
						  const ValueType* val,
						  MatrixType& A_fact);

} // end namespace cusp

#include <cusp/detail/fact.inl>

