#include <cusparse.h>

void cusparseXcsrsv_solve(cusparseHandle_t& handle, cusparseOperation_t transA, int nrow, float alpha, cusparseMatDescr_t& descrM_lo, 
						float* csrValA, int* csrRowPtrA, int* csrColIndA,	
						cusparseSolveAnalysisInfo_t& Analy_lo, const float *x, float *y)
{
    cusparseScsrsv_solve(handle, transA, nrow, alpha, descrM_lo, 
						csrValA, csrRowPtrA, csrColIndA, Analy_lo, x, y);    
}

void cusparseXcsrsv_solve(cusparseHandle_t& handle, cusparseOperation_t transA, int nrow, double alpha, cusparseMatDescr_t& descrM_lo, 
						double* csrValA, int* csrRowPtrA, int* csrColIndA,	
						cusparseSolveAnalysisInfo_t& Analy_lo, const double *x, double *y)
{
    cusparseDcsrsv_solve(handle, transA, nrow, alpha, descrM_lo, 
						csrValA, csrRowPtrA, csrColIndA, Analy_lo, x, y);    
}

void cusparseXcsrsv_analysis(cusparseHandle_t& handle, cusparseOperation_t transA, int nrow, cusparseMatDescr_t& descrM_lo,
							float* csrValA, int* csrRowPtrA, int* csrColIndA,	
							cusparseSolveAnalysisInfo_t& Analy_lo)
{			
	cusparseScsrsv_analysis(handle, transA, nrow, descrM_lo,
			csrValA, csrRowPtrA, csrColIndA, Analy_lo);
}

void cusparseXcsrsv_analysis(cusparseHandle_t& handle, cusparseOperation_t transA, int nrow, cusparseMatDescr_t& descrM_lo,
							double* csrValA, int* csrRowPtrA, int* csrColIndA,	
							cusparseSolveAnalysisInfo_t& Analy_lo)
{			
	cusparseDcsrsv_analysis(handle, transA, nrow, descrM_lo,
			csrValA, csrRowPtrA, csrColIndA, Analy_lo);
}
