#include <mkl_blas.h>
#include <mkl_cblas.h>
#include <mkl_spblas.h>

void mkl_xcsrtrsv(char* cvar1, char* cvar, char* cvar2, int* nrow, float* h_fact_val, int* h_fact_row, int* h_fact_col, float* x, float* y)
{
    mkl_scsrtrsv(cvar1, cvar, cvar2, nrow, h_fact_val, h_fact_row, h_fact_col, x, y);
}

void mkl_xcsrtrsv(char* cvar1, char* cvar, char* cvar2, int* nrow, double* h_fact_val, int* h_fact_row, int* h_fact_col, double* x, double* y)
{
    mkl_dcsrtrsv(cvar1, cvar, cvar2, nrow, h_fact_val, h_fact_row, h_fact_col, x, y);
}

void cblas_xaxpy(int nrow, float alpha, float* x, int inchx, float* y, int inchy)
{
	cblas_saxpy(nrow, alpha, x, inchx, y, inchy);
}

void cblas_xaxpy(int nrow, double alpha, double* x, int inchx, double* y, int inchy)
{
	cblas_daxpy(nrow, alpha, x, inchx, y, inchy);
}

void mkl_xcsrgemv(char* cvar, int* nrow, float* h_val, int* h_row, int* h_col, float* x, float* y)
{
	mkl_scsrgemv(cvar, nrow, h_val, h_row, h_col, x, y);
}

void mkl_xcsrgemv(char* cvar, int* nrow, double* h_val, int* h_row, int* h_col, double* x, double* y)
{
	mkl_dcsrgemv(cvar, nrow, h_val, h_row, h_col, x, y);
}

void cblas_xscal(int nrow, float alpha, float* x, int inch)
{
	cblas_sscal(nrow, alpha, x, inch);
}

void cblas_xscal(int nrow, double alpha, double* x, int inch)
{
	cblas_dscal(nrow, alpha, x, inch);
}
